Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/dialog/QueryAssistDialog.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/dialog/QueryAssistDialog.java	(revision 3060)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/dialog/QueryAssistDialog.java	(revision 3061)
@@ -513,7 +513,6 @@
 	public class WordField extends Composite {
 		
 		ArrayList<QueryAssistDialog.WordPropertyField> propertyFields = new ArrayList<>();
-		// Combo propertiesAllOrOne;
 		
 		Button targetButton;
 		
@@ -525,7 +524,9 @@
 		
 		private int no;
 		
+		private Button allCriteriaButton;
 		
+		
 		/**
 		 * Instantiates a new word field.
 		 *
@@ -581,15 +582,9 @@
 			propertiesFieldComposite.setLayoutData(propertiesvlayout);
 			propertiesFieldComposite.getLayout().numColumns = 2;
 			
-			// propertiesAllOrOne = new Combo(this, SWT.SINGLE-SWT.READ_ONLY);
-			// propertiesAllOrOne.setToolTipText("ALL=all properties test must match / ONE=one property match is enough");
-			// propertiesAllOrOne.add("ALL");
-			// propertiesAllOrOne.add("ONE");
-			// propertiesAllOrOne.select(0);
-			// propertiesAllOrOne.setLayoutData(new GridData(GridData.FILL, GridData.CENTER, false, false));
+			allCriteriaButton = new Button(this, SWT.CHECK);
+			allCriteriaButton.setToolTipText("All properties test are verified");
 			
-			addProperty();
-			
 			targetButton = new Button(this, SWT.CHECK);
 			targetButton.setToolTipText("Check to target the word in the query");
 			targetButton.addSelectionListener(new SelectionListener() {
@@ -642,6 +637,8 @@
 				@Override
 				public void widgetDefaultSelected(SelectionEvent e) {}
 			});
+			
+			addProperty();
 		}
 		
 		private void addProperty() {
@@ -660,7 +657,8 @@
 		}
 		
 		private void updateWidgets() {
-			// propertiesAllOrOne.setEnabled(propertyFields.size() > 1);
+			
+			allCriteriaButton.setEnabled(propertyFields.size() > 1);
 			// propertiesAllOrOne.setVisible(propertyFields.size() > 1);
 			// ((GridData)propertiesAllOrOne.getLayoutData()).exclude = propertyFields.size() < 2;
 			if (propertyFields.size() == 0) {
@@ -692,6 +690,11 @@
 			}
 			query += "["; //$NON-NLS-1$
 			
+			String propertiesAllOrOne = " | ";
+			if (allCriteriaButton.getSelection()) {
+				propertiesAllOrOne = " & ";
+			}
+			
 			int nField = 0;
 			for (WordPropertyField f : propertyFields) {
 				Combo propCombo = f.propCombo;
@@ -699,7 +702,7 @@
 				Combo valueT = f.valueT;
 				if (nField > 0) {
 					// query += " "+(propertiesAllOrOne.getText().equals("ALL")?"&":"|")+" ";
-					query += " & ";
+					query += propertiesAllOrOne;
 				}
 				
 				String p = propCombo.getItem(propCombo.getSelectionIndex());
Index: tmp/org.txm.links.rcp/src/org/txm/links/rcp/handlers/SendSelectionToQueryable.java
===================================================================
--- tmp/org.txm.links.rcp/src/org/txm/links/rcp/handlers/SendSelectionToQueryable.java	(revision 3060)
+++ tmp/org.txm.links.rcp/src/org/txm/links/rcp/handlers/SendSelectionToQueryable.java	(revision 3061)
@@ -55,6 +55,26 @@
 	public abstract String createQuery(ExecutionEvent event, ISelection isel);
 	
 	/**
+	 * Creates the query.
+	 * 
+	 * @param isel
+	 * @return
+	 */
+	public Integer getIndexResult(ExecutionEvent event, ISelection isel) {
+		return null;
+	}
+	
+	/**
+	 * Creates the query.
+	 * 
+	 * @param isel
+	 * @return
+	 */
+	public Integer getSubIndexResult(ExecutionEvent event, ISelection isel) {
+		return null;
+	}
+	
+	/**
 	 * Creates the queries.
 	 * This method is essentially dedicated to be overridden, if needed.
 	 * 
@@ -74,6 +94,8 @@
 			
 			String query = this.createQuery(event, selection);
 			String queries = this.createQueries(event, selection);
+			Integer index = this.getIndexResult(event, selection);
+			Integer subindex = this.getSubIndexResult(event, selection);
 			
 			if ((query == null || query.isEmpty()) && (queries == null || queries.isEmpty())) {
 				Log.warning(Messages.noQueryWasSetCommandCanceled);
@@ -87,6 +109,8 @@
 			TXMPreferences.put(resultParametersNodePath, TXMPreferences.PARENT_PARAMETERS_NODE_PATH, result.getParametersNodePath());
 			TXMPreferences.put(resultParametersNodePath, TXMPreferences.QUERY, query);
 			TXMPreferences.put(resultParametersNodePath, TXMPreferences.QUERIES, queries);
+			TXMPreferences.put(resultParametersNodePath, TXMPreferences.INDEX, index);
+			TXMPreferences.put(resultParametersNodePath, TXMPreferences.SUB_INDEX, subindex);
 			
 			BaseAbstractHandler.executeSendToCommand(event.getCommand().getId(), resultParametersNodePath);
 			// TODO we should test if there is already a linked editor and used it. Do to it we must either A) know which editor class is must be opened B) know why a previous editor has been open
Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/TXTSearchEngine.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/TXTSearchEngine.java	(revision 0)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/TXTSearchEngine.java	(revision 3061)
@@ -0,0 +1,104 @@
+package org.txm.searchengine.cqp;
+
+import java.util.List;
+
+import org.eclipse.core.runtime.IProgressMonitor;
+import org.txm.Toolbox;
+import org.txm.core.engines.EngineType;
+import org.txm.core.results.TXMResult;
+import org.txm.objects.CorpusBuild;
+import org.txm.objects.Match;
+import org.txm.searchengine.core.EmptySelection;
+import org.txm.searchengine.core.IQuery;
+import org.txm.searchengine.core.SearchEngine;
+import org.txm.searchengine.core.SearchEngineProperty;
+import org.txm.searchengine.core.Selection;
+import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
+import org.txm.searchengine.cqp.corpus.CQPCorpus;
+import org.txm.searchengine.cqp.corpus.query.TXTQuery;
+
+public class TXTSearchEngine extends SearchEngine {
+	
+	public static final String NAME = "TXT";
+	
+	/**
+	 * initialization state
+	 */
+	boolean state = false;
+	
+	boolean useNetCQi = false;
+	
+	@Override
+	public String getName() {
+		return TXTSearchEngine.NAME;
+	}
+	
+	/**
+	 * Starts the corpus engine if not remove then launch cqpserver.
+	 *
+	 * @return true, if successful
+	 */
+	@Override
+	public boolean start(IProgressMonitor monitor) throws Exception {
+		return true;
+	}
+	
+	
+	@Override
+	public boolean initialize() {
+		return true;
+	}
+	
+	/**
+	 * Shutdown.
+	 */
+	@Override
+	public boolean stop() {
+		return true;
+	}
+	
+	@Override
+	public boolean isRunning() {
+		return CQPSearchEngine.getEngine().isRunning();
+	}
+	
+	@Override
+	public Selection query(CorpusBuild corpus, IQuery query, String name, boolean saveQuery) throws CqiClientException {
+		if (query instanceof TXTQuery && corpus instanceof CQPCorpus) {
+			TXTQuery tquery = (TXTQuery) query;
+			return CQPSearchEngine.getEngine().query(corpus, tquery.fixQuery(corpus.getLang()), name, saveQuery);
+		}
+		else {
+			return new EmptySelection(query);
+		}
+	}
+	
+	@Override
+	public TXTQuery newQuery() {
+		return new TXTQuery(""); //$NON-NLS-1$
+	}
+	
+	@Override
+	public boolean hasIndexes(CorpusBuild corpus) {
+		return CQPSearchEngine.getEngine().hasIndexes(corpus);
+	}
+	
+	@Override
+	public void notify(TXMResult r, String state) {
+		// nothing to do the CQPEngine will manage the notifications
+	}
+	
+	public static TXTSearchEngine getEngine() {
+		return (TXTSearchEngine) Toolbox.getEngineManager(EngineType.SEARCH).getEngine(TXTSearchEngine.NAME);
+	}
+	
+	@Override
+	public String getValueForProperty(Match match, SearchEngineProperty property) {
+		return CQPSearchEngine.getEngine().getValueForProperty(match, property);
+	}
+	
+	@Override
+	public List<String> getValuesForProperty(Match match, SearchEngineProperty property) {
+		return CQPSearchEngine.getEngine().getValuesForProperty(match, property);
+	}
+}

Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/query/TXTQuery.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/query/TXTQuery.java	(revision 0)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/query/TXTQuery.java	(revision 3061)
@@ -0,0 +1,68 @@
+package org.txm.searchengine.cqp.corpus.query;
+
+import java.util.ArrayList;
+import java.util.Locale;
+
+import org.txm.searchengine.core.IQuery;
+import org.txm.searchengine.core.SearchEngine;
+import org.txm.searchengine.cqp.TXTSearchEngine;
+import org.txm.tokenizer.SimpleStringTokenizer;
+
+public class TXTQuery implements IQuery {
+	
+	String raw = "";
+	
+	public TXTQuery(String query) {
+		raw = query;
+	}
+	
+	@Override
+	public String getQueryString() {
+		return raw;
+	}
+	
+	@Override
+	public boolean isEmpty() {
+		return raw == null || raw.isEmpty();
+	}
+	
+	@Override
+	public SearchEngine getSearchEngine() {
+		return TXTSearchEngine.getEngine();
+	}
+	
+	@Override
+	public IQuery setQuery(String rawQuery) {
+		raw = rawQuery;
+		return this;
+	}
+	
+	@Override
+	public IQuery fixQuery() {
+		return fixQuery(Locale.getDefault().getCountry());
+	}
+	
+	@Override
+	public boolean equals(IQuery q) {
+		return raw.equals(q.getQueryString());
+	}
+	
+	@Override
+	public String asString() {
+		return raw;
+	}
+	
+	public IQuery fixQuery(String lang) {
+		// SimpleStringTokenizer tokenizer = new SimpleStringTokenizer(lang); // TODO setup the tokenizer to not create tokens * and ? when they are next to letters
+		StringBuilder buffer = new StringBuilder();
+		String[] rs = raw.split(" ");
+		for (int i = 0; i < rs.length; i++) {
+			String r = rs[i];
+			if (i > 0) buffer.append(" ");
+			r = CQLQuery.addBackSlash(r);
+			buffer.append("\"" + r.replace("\\*", ".*") + "\"%cd");
+		}
+		System.out.println("QUERY=" + buffer.toString());
+		return new CQLQuery(buffer.toString());
+	}
+}

Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/query/Match.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/query/Match.java	(revision 3060)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/query/Match.java	(revision 3061)
@@ -43,19 +43,19 @@
  * @author jmague, mdecorde
  */
 public class Match extends org.txm.objects.Match {
-
+	
 	/** The start. */
 	protected int start;
-
+	
 	/** The end. */
 	protected int end;
 	
 	/** The target position */
 	protected int target = -1;
-
+	
 	/** The query result. */
-	//private QueryResult queryResult;
-
+	// private QueryResult queryResult;
+	
 	/**
 	 * Instantiates a new match.
 	 * 
@@ -67,19 +67,20 @@
 	public Match(int start, int end) {
 		this.start = start;
 		this.end = end;
-		//this.queryResult = queryResult;
+		// this.queryResult = queryResult;
 	}
-
+	
 	public Match(int start, int end, int target) {
-		this(start,end);
+		this(start, end);
 		this.target = target;
 	}
-
+	
 	/**
 	 * Gets the start.
 	 * 
 	 * @return the start
 	 */
+	@Override
 	public int getStart() {
 		return start;
 	}
@@ -89,28 +90,30 @@
 	 * 
 	 * @return the start
 	 */
+	@Override
 	public int getTarget() {
 		return target;
 	}
-
+	
 	/**
 	 * Gets the end.
 	 * 
 	 * @return the end
 	 */
+	@Override
 	public int getEnd() {
 		return end;
 	}
-
-//	/**
-//	 * Gets the query result.
-//	 * 
-//	 * @return the query result
-//	 */
-//	public QueryResult getQueryResult() {
-//		return queryResult;
-//	}
-
+	
+	// /**
+	// * Gets the query result.
+	// *
+	// * @return the query result
+	// */
+	// public QueryResult getQueryResult() {
+	// return queryResult;
+	// }
+	
 	/**
 	 * Gets the value for property for the first position of the match.
 	 * 
@@ -124,11 +127,11 @@
 	 */
 	public String getValueForProperty(Property property)
 			throws CqiClientException {
-		List<Match> match = new ArrayList<Match>();
+		List<Match> match = new ArrayList<>();
 		match.add(this);
 		return Match.getValuesForProperty(property, match).get(0);
 	}
-
+	
 	/**
 	 * Gets the values for property for all the positions of the match.
 	 * 
@@ -147,7 +150,7 @@
 			positions[i] = this.start + i;
 		return getValuesForProperty(property, positions);
 	}
-
+	
 	/**
 	 * Gets the values for property.
 	 * 
@@ -182,13 +185,12 @@
 	 * @throws CqiClientException
 	 *             the cqi client exception
 	 */
-	public static List<String> getValuesForProperty(Property property,
-			org.txm.objects.Match match) throws CqiClientException {
+	public static List<String> getValuesForProperty(Property property, org.txm.objects.Match match) throws CqiClientException {
 		int[] starts = new int[1];
 		starts[0] = match.getStart();
 		return getValuesForProperty(property, starts);
 	}
-
+	
 	/**
 	 * Gets the values for property.
 	 * 
@@ -211,11 +213,13 @@
 						positions);
 				return Arrays.asList(cqiClient.struc2Str(property
 						.getQualifiedName(), struc));
-			} else {
+			}
+			else {
 				return Arrays.asList(cqiClient.cpos2Str(property
 						.getQualifiedName(), positions));
 			}
-		} catch (Exception e) {
+		}
+		catch (Exception e) {
 			throw new CqiClientException(e);
 		}
 	}
@@ -239,18 +243,20 @@
 		try {
 			if (property instanceof StructuralUnitProperty) {
 				int[] struc = cqiClient.cpos2Struc(property.getQualifiedName(),
-						new int[] {position});
+						new int[] { position });
 				return cqiClient.struc2Str(property
 						.getQualifiedName(), struc)[0];
-			} else {
+			}
+			else {
 				return cqiClient.cpos2Str(property
-						.getQualifiedName(), new int[] {position})[0];
+						.getQualifiedName(), new int[] { position })[0];
 			}
-		} catch (Exception e) {
+		}
+		catch (Exception e) {
 			throw new CqiClientException(e);
 		}
 	}
-
+	
 	/**
 	 * Gets the ids.
 	 *
@@ -262,30 +268,34 @@
 	public int[] getIds(Property property, int[] positions)
 			throws CqiClientException {
 		AbstractCqiClient cqiClient = CorpusManager.getCorpusManager().getCqiClient();
-
+		
 		try {
 			if (property instanceof StructuralUnitProperty) {
 				int[] struc = cqiClient.cpos2Struc(property.getQualifiedName(),
 						positions);
 				return struc;
-			} else {
+			}
+			else {
 				int[] ids = cqiClient.cpos2Id(property.getQualifiedName(),
 						positions);
 				return ids;
 			}
-		} catch (Exception e) {
+		}
+		catch (Exception e) {
 			throw new CqiClientException(e);
 		}
 	}
-
+	
+	@Override
 	public void setEnd(int p) {
 		this.end = p;
 	}
-
+	
+	@Override
 	public void setStart(int p) {
 		this.start = p;
 	}
-
+	
 	@Override
 	public void setTarget(int p) {
 		this.target = p;
Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/query/MatchUtils.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/query/MatchUtils.java	(revision 3060)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/query/MatchUtils.java	(revision 3061)
@@ -2,6 +2,7 @@
 
 import java.util.ArrayList;
 import java.util.List;
+import org.txm.objects.Match;
 
 public class MatchUtils {
 	
@@ -34,7 +35,7 @@
 	 * @param list the list of matches
 	 * @return an array of all positions of the specified list of matches
 	 */
-	public static int[] toPositions(List<Match> list) {
+	public static int[] toPositions(List<? extends Match> list) {
 		ArrayList<Integer> result = new ArrayList<>();
 		for (Match m : list) {
 			if (m.getStart() == m.getEnd()) {
@@ -59,7 +60,7 @@
 	 * @param match
 	 * @return array of int position from a Match
 	 */
-	public int[] toPositions(Match match) {
+	public static int[] toPositions(Match match) {
 		return toPositions(match, match);
 	}
 	
@@ -70,7 +71,7 @@
 	 * @return array of int position from a Match start to another Match end
 	 */
 	public static int[] toPositions(Match match1, Match match2) {
-		return toPositions(match1.start, match2.end);
+		return toPositions(match1.getStart(), match2.getEnd());
 	}
 	
 	/**
